"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var error_message_service_1 = require('../services/error-message.service');
var ErrorsComponent = (function () {
    function ErrorsComponent(errorMessageService) {
        this.errorMessageService = errorMessageService;
    }
    ErrorsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.formGroup = this.form.form;
        this.formGroup.valueChanges.subscribe(function () { return _this.getErrors(); });
        this.form.ngSubmit.subscribe(function () { return _this.getErrors(); });
    };
    ErrorsComponent.prototype.getErrors = function () {
        if (this.form.submitted) {
            this.errors = [];
            for (var _i = 0, _a = Object.keys(this.formGroup.controls); _i < _a.length; _i++) {
                var fieldName = _a[_i];
                if (this.formGroup.controls[fieldName].errors) {
                    this.addErrors(fieldName, this.formGroup.controls[fieldName].errors);
                }
            }
        }
    };
    ErrorsComponent.prototype.addErrors = function (fieldName, errors) {
        for (var _i = 0, _a = Object.keys(errors); _i < _a.length; _i++) {
            var error = _a[_i];
            this.errors.push({
                field: this.errorMessageService.getFieldName(fieldName),
                message: this.errorMessageService.getErrorMessage(error, errors[error])
            });
        }
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', forms_1.FormGroupDirective)
    ], ErrorsComponent.prototype, "form", void 0);
    ErrorsComponent = __decorate([
        core_1.Component({
            selector: 'errors',
            template: "<ul>\n                <li *ngFor=\"let error of errors\">\n                    <b>{{error.field}}</b>: {{error.message}}\n                </li>\n            </ul>"
        }), 
        __metadata('design:paramtypes', [error_message_service_1.ErrorMessageService])
    ], ErrorsComponent);
    return ErrorsComponent;
}());
exports.ErrorsComponent = ErrorsComponent;
//# sourceMappingURL=errors.component.js.map