"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ErrorMessageService = (function () {
    function ErrorMessageService() {
        this.errorMessages = {
            required: 'is required',
            minlength: 'must be at least {{requiredLength}} characters long',
            maxlength: 'must be no more than {{requiredLength}} characters long'
        };
    }
    /**
      * Set custom error messages that override the default ones
      * @param errorMessages An object {key: message}
      */
    ErrorMessageService.prototype.setErrorMessages = function (errorMessages) {
        this.errorMessages = Object.assign(this.errorMessages, errorMessages);
    };
    /**
      * Set custom fields names
      * @param errorMessages An object {key: name}
      */
    ErrorMessageService.prototype.setFieldsNames = function (fieldsNames) {
        this.fieldsNames = fieldsNames;
    };
    ErrorMessageService.prototype.getErrorMessage = function (error, params) {
        var errorMessage = this.errorMessages[error];
        if (params && errorMessage) {
            for (var _i = 0, _a = Object.keys(params); _i < _a.length; _i++) {
                var param = _a[_i];
                errorMessage = errorMessage.replace('{{' + param + '}}', params[param]);
            }
        }
        return errorMessage;
    };
    ErrorMessageService.prototype.getFieldName = function (field) {
        if (this.fieldsNames && this.fieldsNames[field]) {
            return this.fieldsNames[field];
        }
        return field.toLowerCase()
            .split('_')
            .map(function (i) { return i[0].toUpperCase() + i.substring(1); })
            .join(' ');
    };
    ErrorMessageService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], ErrorMessageService);
    return ErrorMessageService;
}());
exports.ErrorMessageService = ErrorMessageService;
//# sourceMappingURL=error-message.service.js.map